/*Copyright ©2015 TommyLemon(https://github.com/TommyLemon)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.*/

package com.example.testselfdefinview;

import java.util.List;

import com.example.testselfdefinview.ShowView.OnViewClickListener;

import zuo.biao.library.base.BaseAdapter;
import android.app.Activity;
import android.view.View;
import android.view.ViewGroup;

/**adapter模板
 * @author Lemon
 * @use new ShowAdapter(),具体参考.DemoActivity(setList方法内)
 */
public class ShowAdapter extends BaseAdapter<Show> {
	//	private static final String TAG = "ShowAdapter";

	private OnViewClickListener onViewClickListener;
	public void setOnViewClickListener(OnViewClickListener onViewClickListener) {
		this.onViewClickListener = onViewClickListener;
	}

	public ShowAdapter(Activity context, List<Show> list) {
		super(context, list);
	}

	//getView使用自定义View的写法<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		ShowView demoView = convertView == null ? null : (ShowView) convertView.getTag();
		if (convertView == null) {
			demoView = new ShowView(context, resources);
			convertView = demoView.createView(inflater, getItemViewType(position));

			convertView.setTag(demoView);
		}

		demoView.setView(getItem(position), position, getItemViewType(position));
		demoView.setOnViewClickListener(onViewClickListener);

		return convertView;
	}

	//getView使用自定义View的写法>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	@Override
	public long getItemId(int position) {
		return getItem(position).getId();
	}


}
