package com.example.testselfdefinview;

import java.util.List;

import zuo.biao.library.base.BaseView;
import zuo.biao.library.ui.WebViewActivity;
import zuo.biao.library.util.ImageLoaderUtil;
import zuo.biao.library.util.Log;
import zuo.biao.library.util.StringUtil;
import zuo.biao.library.util.TimeUtil;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.res.Resources;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.TextView;

/**生活秀View
 * @author Lemon
 */
public class ShowView extends BaseView<Show> implements OnClickListener, OnItemClickListener {
	private static final String TAG = "ShowView";

	public interface OnViewClickListener {
		void onViewClick(ShowView showView);
	}

	private OnViewClickListener onViewClickListener;
	public void setOnViewClickListener(OnViewClickListener onViewClickListener) {
		this.onViewClickListener = onViewClickListener;
	}

	public ShowView(Activity context, Resources resources) {
		super(context, resources);
	}


	public View llShowView;

	public ImageView ivShowViewHead;

	public TextView tvShowViewName;
	public TextView tvShowViewDate;

	public GridView gvShowView;

	public TextView tvShowViewContent;
	public View ivShowViewMenu;
	@SuppressLint("InflateParams")
	@Override
	public View createView(LayoutInflater inflater) {
		convertView = inflater.inflate(R.layout.show_view, null);

		llShowView = findViewById(R.id.llShowView);

		ivShowViewHead = (ImageView) findViewById(R.id.ivShowViewHead);

		tvShowViewName = (TextView) findViewById(R.id.tvShowViewName);
		tvShowViewContent = (TextView) findViewById(R.id.tvShowViewContent);

		gvShowView = (GridView) findViewById(R.id.gvShowView);

		tvShowViewDate = (TextView) findViewById(R.id.tvShowViewDate);
		ivShowViewMenu = findViewById(R.id.ivShowViewMenu);

		return convertView;
	}



	private Show data;//传进来的数据
	@Override
	public Show getData() {
		return data;
	}


	@Override
	public void setView(Show data_){
		if (data_ == null) {
			Log.e(TAG, "setView data_ == null >> return;");
			return;
		}
		this.data = data_;

		ImageLoaderUtil.loadImage(ivShowViewHead, data.getHead(), ImageLoaderUtil.TYPE_OVAL);

		tvShowViewName.setText(StringUtil.getTrimedString(data.getName() + data.getId()));

		tvShowViewContent.setVisibility(StringUtil.isNotEmpty(data.getContent(), true) ? View.VISIBLE : View.GONE);
		tvShowViewContent.setText(StringUtil.getTrimedString(data.getContent()));

		tvShowViewDate.setText(TimeUtil.getSmartDate(data.getDate()));

		setPicture();

		llShowView.setOnClickListener(this);

		ivShowViewHead.setOnClickListener(this);
		tvShowViewName.setOnClickListener(this);

		ivShowViewMenu.setOnClickListener(this);
		gvShowView.setOnItemClickListener(this);
	}


	private List<String> pictureList;
	private PictureAdapter adapter;
	/**设置图片
	 */
	private void setPicture() {
		pictureList = data.getPictureList();

		gvShowView.setVisibility(View.GONE);

		final int pictureCount = pictureList == null ? 0 : pictureList.size();
		if (pictureCount <= 0) {
			Log.i(TAG, "setList pictureCount <= 0 >> lvModel.setAdapter(null); return;");
			adapter = null;
			gvShowView.setAdapter(null);
			return;
		}
		if (pictureCount > 9) {
			pictureList = pictureList.subList(0, 9);
		}

		gvShowView.setVisibility(View.VISIBLE);
		gvShowView.setNumColumns(pictureCount <= 1 ? 1 : 3);
		if (adapter == null) {
			adapter = new PictureAdapter(context, pictureList);
			gvShowView.setAdapter(adapter);
		} else {
			adapter.refresh(pictureList);
		}

		gvShowView.post(new Runnable() {

			@SuppressLint("NewApi")
			@Override
			public void run() {
				int row = 1;
				if (pictureCount >= 7 || gvShowView.getNumColumns() <= 1) {
					row = 3;
				} else if (pictureCount >= 4) {
					row = 2;
				}
				android.view.ViewGroup.LayoutParams lp = gvShowView.getLayoutParams();
				lp.height = row * (gvShowView.getWidth() - 2 * gvShowView.getHorizontalSpacing()) / 3
						+ (row-1) * gvShowView.getVerticalSpacing();
				gvShowView.setLayoutParams(lp);
			}
		});


	}




	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.ivShowViewHead:
			toActivity(WebViewActivity.createIntent(context, "ZBLibrary", "https://github.com/TommyLemon/Android-ZBLibrary"));
			break;
		case R.id.tvShowViewName:
			toActivity(WebViewActivity.createIntent(context, "Tommy", "http://my.oschina.net/u/2437072"));
			break;
		case R.id.ivShowViewMenu:
			showShortToast("菜单");
			break;
		default:
			if (onViewClickListener != null) {
				onViewClickListener.onViewClick(this);
			}
			break;
		}
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
		toActivity(WebViewActivity.createIntent(context, "Picture" + position
				, adapter == null ? null : adapter.getItem(position)));
	}


}
